<?php

namespace Toloka\PhpApi;

use Psr\Http\Client\ClientInterface as HttpClientInterface;
use Psr\Log\LoggerInterface;
use Psr\SimpleCache\CacheInterface;

class Client implements ClientInterface {

  /**
   * Hurtom Toloka base url.
   *
   * @var string
   */
  protected string $base_url;

  /**
   * Http client.
   *
   * @var HttpClientInterface
   */
  protected HttpClientInterface $httpClient;

  /**
   * Cache bin.
   *
   * @var CacheInterface
   */
  protected CacheInterface $cache;

  /**
   * Events logger.
   *
   * @var LoggerInterface
   */
  protected LoggerInterface $logger;

  /**
   * Toloka client constructor.
   *
   * @param string $base_url
   * @param CacheInterface|NULL $cache
   * @param LoggerInterface|NULL $logger
   */
  public function __construct(
    string $base_url = 'https://toloka.to',
    HttpClientInterface $httpClient,
    CacheInterface $cache,
    LoggerInterface $logger
  ) {
    $this->httpClient = $httpClient;
    $this->cache = $cache;
    $this->logger = $logger;
  }

  /**
   * {@inheritDoc}
   */
  public function login(string $login, string $password): void {
    // TODO: Implement login() method.
  }

  /**
   * {@inheritDoc}
   */
  public function isLoggedIn(): bool {
    // TODO: Implement isLoggedIn() method.
  }

  /**
   * {@inheritDoc}
   */
  public function logout(): void {
    // TODO: Implement logout() method.
  }

  /**
   * {@inheritDoc}
   */
  public function getTopic(int $id): TopicInterface {
    // TODO: Implement getTopic() method.
  }


}
